/* File name     : force_memtest.c
 * Creation date : May 1993
 * Author        : Y.Yasu, Online group, Physics department, KEK
 * Modified      : August 1994, Y.Yasu
 */

#include <stdio.h>
#include <sys/file.h>
#include<sys/types.h>
#ifdef HPRT
#include <shmmap.h>
#else
#include<sys/mman.h>
#endif
#include<sys/time.h> 
#include "vmelib.h"
#include "force.h"
#define LOOP 1
static union bufw bufw;
static union bufr bufr;
static volatile char  *mm_char;
static volatile short *mm_short;
static volatile long  *mm_long;

main(argc, argv)
int argc;
char **argv; {
    int i, j;
    volatile caddr_t vme_addr;
    struct timeval tp1,tp2;
    struct timezone tzp;

    if( argc == 2 )
        for (i = 0; i < 4; i++)
	    bufw.c[i] = argv[1][i];
    else {
        bufw.c[0] = 'a';
	bufw.c[1] = 'b';
	bufw.c[2] = 'c';
	bufw.c[3] = 'd';
    }
    for(i = 1; i< MEM_SIZE_LONG; i++ )
        bufw.l[i] = bufw.l[0];
/*
    vme_addr = (volatile caddr_t)vme_mapopen(VME_A24D32MODE, MEM_A24D16,
*/
    vme_addr = (volatile caddr_t)vme_mapopen(VME_A32D32MODE, MEM_A32D32,
                                             MEM_SIZE);
    if (vme_addr == ( volatile caddr_t)-1) {
        printf("FORCE memory cannot open! \n");
        exit(1);
    }
    mm_char = (volatile char *)vme_addr;
    mm_short = (volatile short *)vme_addr;
    mm_long = (volatile long *)vme_addr;

    printf("address = %x\n", mm_long);

/* 32 bit VME WRITE */
    printf("doloop : from HOST to VME in longword\n");
    for( i = 0; i<LOOP; i++)
        for( j = 0; j< MEM_SIZE_LONG; j++)
            mm_long[j] = (volatile long)bufw.l[j];
    printf("doloop : from VME to HOST in charword\n");
    for( i = 0; i< 1; i++)
        for( j = 0; j<1; j++)
            bufr.c[j] = (char)mm_char[j];
    for( i = 0; i<LOOP; i++)
        for( j = 0; j<MEM_SIZE_CHAR; j++)
            bufr.c[j] = (char)mm_char[j];
    printf("doloop : comparison read data with written data\n");
    check_data();
    printf("doloop : clear HOST memory\n");
    for(i = 0; i < MEM_SIZE_LONG; i++ )
        bufr.l[i] = 0;
    printf("doloop : from host to VME in shortword\n");
    for( i = 0; i<LOOP; i++)
        for( j = 0; j<MEM_SIZE_SHORT; j++)
            bufr.s[j] = (short)mm_short[j];
    printf("doloop : comparison read data with written data\n");
    check_data();
    printf("doloop : clear HOST memory\n");
    for(i = 0; i < MEM_SIZE_LONG; i++ )
        bufr.l[i] = 0;
    printf("doloop : from VME to HOST in longword\n");
    for( i = 0; i<LOOP; i++)
        for( j = 0; j<MEM_SIZE_LONG; j++)
            bufr.l[j] = (long)mm_long[j];
    printf("doloop : comparison read data with written data\n");
    check_data();
    printf("doloop : clear HOST memory\n");
    for(i = 0; i < MEM_SIZE_LONG; i++ )
        bufr.l[i] = 0;
    printf("doloop : clear VME memory in longword\n");
    for( i = 0; i<LOOP; i++)
        for( j = 0; j< MEM_SIZE_LONG; j++)
            mm_long[j] = (volatile long)0;

/* 16 bit VME WRITE */
    printf("doloop : from HOST to VME in shortword\n");
    for( i = 0; i<LOOP; i++)
        for( j = 0; j< MEM_SIZE_SHORT; j++)
            mm_short[j] = (volatile short)bufw.s[j];
    printf("doloop : from VME to HOST in shortword\n");
    for( i = 0; i<LOOP; i++)
        for( j = 0; j<MEM_SIZE_CHAR; j++)
            bufr.c[j] = (char)mm_char[j];
    printf("doloop : comparison read data with written data\n");
    check_data();
    printf("doloop : clear HOST memory\n");
    for(i = 0; i < MEM_SIZE_LONG; i++ )
        bufr.l[i] = 0;
    printf("doloop : from host to VME in shortword\n");
    for( i = 0; i<LOOP; i++)
        for( j = 0; j<MEM_SIZE_SHORT; j++)
            bufr.s[j] = (short)mm_short[j];
    printf("doloop : comparison read data with written data\n");
    check_data();
    printf("doloop : clear HOST memory\n");
    for(i = 0; i < MEM_SIZE_LONG; i++ )
        bufr.l[i] = 0;
    printf("doloop : from VME to HOST in longword\n");
    for( i = 0; i<LOOP; i++)
        for( j = 0; j<MEM_SIZE_LONG; j++)
            bufr.l[j] = (long)mm_long[j];
    printf("doloop : comparison read data with written data\n");
    check_data();
    printf("doloop : clear HOST memory\n");
    for(i = 0; i < MEM_SIZE_LONG; i++ )
        bufr.l[i] = 0;
    printf("doloop : clear VME memory in longword\n");
    for( i = 0; i<LOOP; i++)
        for( j = 0; j< MEM_SIZE_LONG; j++)
            mm_long[j] = (volatile long)0;

/* 8 bit VME WRITE */
    printf("doloop : from HOST to VME in charword\n");
    for( i = 0; i<LOOP; i++)
        for( j = 0; j< MEM_SIZE_CHAR; j++)
            mm_char[j] = (volatile char)bufw.c[j];
    printf("doloop : from VME to HOST in charword\n");
    for( i = 0; i<LOOP; i++)
        for( j = 0; j<MEM_SIZE_CHAR; j++)
            bufr.c[j] = (char)mm_char[j];
    printf("doloop : comparison read data with written data\n");
    check_data();
    printf("doloop : clear HOST memory\n");
    for(i = 0; i < MEM_SIZE_LONG; i++ )
        bufr.l[i] = 0;
    printf("doloop : from host to VME in shortword\n");
    for( i = 0; i<LOOP; i++)
        for( j = 0; j<MEM_SIZE_SHORT; j++)
            bufr.s[j] = (short)mm_short[j];
    printf("doloop : comparison read data with written data\n");
    check_data();
    printf("doloop : clear HOST memory\n");
    for(i = 0; i < MEM_SIZE_LONG; i++ )
        bufr.l[i] = 0;
    printf("doloop : from VME to HOST in longword\n");
    for( i = 0; i<LOOP; i++)
        for( j = 0; j<MEM_SIZE_LONG; j++)
            bufr.l[j] = (long)mm_long[j];
    printf("doloop : comparison read data with written data\n");
    check_data();
    printf("doloop : clear HOST memory\n");
    for(i = 0; i < MEM_SIZE_LONG; i++ )
        bufr.l[i] = 0;
    printf("doloop : clear VME memory in longword\n");
    for( i = 0; i<LOOP; i++)
        for( j = 0; j< MEM_SIZE_LONG; j++)
            mm_long[j] = (volatile long)0;
}

check_data() {
    int i;

    for(i = 0; i < MEM_SIZE_LONG; i++)
        if( bufr.l[i] != bufw.l[i] ) {
            printf("error at location %d\n", i);
            printf("written data = %c\n", bufw.c[i*4],bufw.c[i*4+1],
		   bufw.c[i*4+2],bufw.c[i*4+3]);
	    printf("read data    = %c\n", bufr.c[i*4],bufr.c[i*4+1],
		   bufr.c[i*4+2],bufr.c[i*4+3]);
            exit(1);
        }
}

