/* File name     : vs_check_n.c
 * Creation date : November 1994
 * Author        : Y.Yasu, Online group, Physics department, KEK
 * Description   : The program checks the function of VME Visual Scaler
 *                 produced by KEK. It makes pulses to V.S. and checks the
 *                 count by readding V.S. with the written count.
 *                 vs_check_n cnt period num
 *                 cnt -> reputation count
 *                 period -> check count in the period
 *                 num -> channel #
 */

#include <stdio.h>
#include<sys/types.h>
#include "vmelib.h"
#include "vs.h"
#include "intreg.h"
#define INTREG_VECTOR INTREG_VECTOR0

union vs vsdata;
volatile union vs *vs, *vs_base;
union channel8data ch8;
volatile struct intreg *mm;

long swapword();

main(argc, argv)
int argc;
char **argv;
{
    int i, j;
    int loop, error_count;
    volatile caddr_t vme_addr, mm_t;
    int period;
    int ch, module;

    if( argc < 2 ) loop = 10000;
    else loop = atoi(argv[1]);
    if( argc < 3 ) period = 1;
    else period = atoi(argv[2]);
    if( argc < 4 ) module = 1;
    else module = atoi(argv[3]);
    if( argc < 5 ) ch = 0;
    else ch = atoi(argv[4]);

    vme_addr = (volatile caddr_t)vme_mapopen(VME_A24D16MODE, VS_ADDR,
                                             VS_SIZE*module);
    if (vme_addr == (volatile caddr_t)-1 ) {
        printf("visual scaler cannot open! \n");
        exit(1);
    }
    vs_base = (volatile union vs *)vme_addr;
    printf("address of Visual Scaler = %x\n", vs_base);
    
    vme_addr = (volatile caddr_t)vme_mapopen(VME_A16D16MODE, INTREG_ADDR,
                                             INTREG_SIZE);
    if (vme_addr == (volatile caddr_t)-1 ) {
        printf("intreg cannot open! \n");
        exit(1);
    }
    mm = (volatile struct intreg *)vme_addr;
    printf("address of Interrupt Register = %x\n", mm);

    printf("csr0 of I.R. = %x\n", mm->csr[0]);

    for(i = 0; i < module; i++ ) {
      vs = vs_base + i;
      printf("Reset V.S. module # = %d ...\n", i);
      j = vs->ch8[0].data[0];
      vs->reg[0xFE/2] = 0xFF;
    }
    mm->out = 0;
    error_count = 0;

    for( i = 0; i < loop; i++) {
      if( i%period == 0) {
	for(j = 0; j < module; j++ ) {
	  vs = vs_base + j;
	  ch8.data[0] = vs->ch8[ch].data[0];
	  ch8.data[1] = vs->ch8[ch].data[1];
#if defined(ULTRIX) || defined(DEC)
	  swapword( &ch8.ldata );
#endif
	  bcd2i( &ch8.ldata );
	  if( ch8.ldata != i ) {
	    printf("module # = %d\n", j);
	    printf("Error : written pulse = %x read data = %x at ch. = %d\n",
		   i, ch8.ldata, ch);
	    error_count++;
	    if( error_count > 20 ) exit(0);
	  }
	}
	if( error_count > 20 ) exit(0);
      }
      mm->pulse = 0xFF;
      mm->csr[0] = 1;
    }
}



