/* File name     : intdrvr.h
 * Creation date : September 1993
 * Author        : Y.Yasu, Online group, Physics department, KEK
 */

struct int_data {
  struct driverhead int_info;
  struct intvector *vector;
  int intdrvr_sem;
  int interrupt_enable;
  int interrupt_vector;
  int interrupt_count;
  int interrupt_flag;
  int timeout_number;
};
typedef struct int_data intdrvr_data;

/* File name     : vme_config.h
 * Creation date : September 1993
 * Author        : Y.Yasu, Online group, Physics department, KEK
 * Modified      : August 1994, Y.Yasu
 *               : For HP-RT
 */

#define VME_A16SIZE        0xFF00
#define VME_A16D16SIZE     0xFF00
#define VME_A16D32SIZE     0xFF00
#define VME_A24SIZE      0x100000
#define VME_A24D16SIZE   0x100000
#define VME_A24D32SIZE   0x100000
#define VME_A32SIZE     0x2000000
#define VME_A32D16SIZE  0x2000000
#define VME_A32D32SIZE  0x2000000

#define VME_A16BASE        0x0000
#define VME_A16D16BASE     0x0000
#define VME_A16D32BASE     0x0000
#define VME_A24BASE      0x000000
#define VME_A24D16BASE   0x000000
#define VME_A24D32BASE   0x000000
#define VME_A32BASE    0x10000000
#define VME_A32D16BASE 0x10000000
#define VME_A32D32BASE 0x10000000

/* File name     : vme_common.h
 * Creation date : September 1993
 * Author        : Y.Yasu, Online group, Physics department, KEK
 */

struct vmecmd {
    int intrno;
    int data;
    int reply1;
    int reply2;
};

struct vmedmacmd {
    unsigned int vme_address;
    unsigned int vme_mode;
};

#define VMEIOC_INTINIT     1
#define VMEIOC_INTOPEN     2
#define VMEIOC_INTCLOSE    3
#define VMEIOC_INTENABLE   4
#define VMEIOC_INTDISABLE  5
#define VMEIOC_INTWAIT     6
#define VMEIOC_INTNOWAIT   7
#define VMEIOC_INTCLEAR    8
#define VMEIOC_INTCHECK    9

#define VMEIOC_DMAOPEN     10
#define VMEIOC_DMACLOSE    11
#define VMEIOC_DMAINIT     12
#define VMEIOC_DMASETUP    13
#define VMEIOC_DMAGETINFO  14

#define VME_A16D16MODE 1
#define VME_A16D32MODE 2
#define VME_A24D16MODE 3
#define VME_A32D32MODE 4
#define VME_A32D16MODE 5
#define VME_A24D32MODE 6
#define VME_A32D32BLTMODE 7
#define VME_A32D64BLTMODE 8
/* File name     : vme.h
 * Creation date : September 1993
 * Author        : Y.Yasu, Online group, Physics department, KEK
 */

#define VME_INTR0 0
#define VME_INTR1 1
#define VME_INTR2 2
#define VME_INTR3 3
#define VME_INTR4 4
#define VME_INTR5 5
#define VME_INTR6 6
#define VME_INTR7 7
#define VME_INTR8 8
#define VME_INTR9 9
#define VME_MIN_VECTOR 0xf0
#define VME_MAX_VECTOR 0xf9
#define VME_TOTAL_VECTOR ( VME_MAX_VECTOR - VME_MIN_VECTOR + 1 )
#define VME_K_TIMEOUT 30 /* unit second */

